//+------------------------------------------------------------------+
//|                                                         STOP.mq4 |
//|                                                            Verdi |
//|                                                  nemo811@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Verdi"
#property link      "nemo811@mail.ru"

extern double RM = 4.000; //  %  

double Balans,Equity,FlowLoss;

int init()
  {

   if (!IsTesting())
    {
     if(!IsExpertEnabled())
      {
       Alert("   !");
       Comment("   !");
       return(0);
      }
     else
      {
       Comment("  .   .");
       Print("  .   .");
      }
    }

   return(0);
  }

int deinit()
  {

   if (!IsTesting())
    {
     Print("  ().");
    }

   return(0);
  }

int start()
  {

   RefreshRates();

   if(!IsTradeAllowed())
    {
     Comment("    ,    .");
     return(0);
    }

   Balans=AccountBalance();
   Equity=AccountEquity();

   if (Balans<=Equity)
    {
     FlowLoss = 0;
    }
   else
    {
     FlowLoss=NormalizeDouble(100-Equity*100/Balans,3);
    }

   Comment("RM - ",RM," %\n",
           "FlowLoss - ",FlowLoss," %\nwww.mt4.ucoz.com");

   double LotR;
   double SchBuyLots  = NormalizeDouble(SchBuyLots_b(),8);
   double SchSellLots = NormalizeDouble(SchSellLots_b(),8);
   LotR=SchBuyLots-SchSellLots;

   if (FlowLoss>RM && SchBuyLots!=SchSellLots)
    {
     for (int i=1; i<=1; i++)
      {
       if (LotR<0)
        {
         OPENORDER ("Buy");
        }
       if (LotR>0)
        {
         OPENORDER ("Sell");
        }
      }
    }

   return(0);
  }
//+------------------------------------------------------------------+

double SchBuyLots_b()
 {
  double SchBuyLots=0;
  int i;
  string SMB=Symbol();
  for (i=OrdersTotal()-1;i>=0;i--)
   {
    if (!OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
     {
      Alert (" ",GetLastError(),"  !");
      Print (" ",GetLastError(),"  !");
     }
    else
     {
      if(OrderSymbol()==SMB && OrderType()==OP_BUY)
       {
        SchBuyLots=SchBuyLots+OrderLots();
       }
     }
   }
  return(SchBuyLots);
 }

double SchSellLots_b()
 {
  double SchSellLots=0;
  int i;
  string SMB=Symbol();
  for (i=OrdersTotal()-1;i>=0;i--)
   {
    if (!OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
     {
      Alert (" ",GetLastError(),"  !");
      Print (" ",GetLastError(),"  !");
     }
    else
     {
      if(OrderSymbol()==SMB && OrderType()==OP_SELL)
       {
        SchSellLots=SchSellLots+OrderLots();
       }
     }
   }
  return(SchSellLots);
 }
 
void OPENORDER(string ord)
 {
  int ticket = -1;

  double Lot;
  double SchBuyLots  = SchBuyLots_b();
  double SchSellLots = SchSellLots_b();

  Lot=MathAbs(SchBuyLots-SchSellLots);

  while (ticket<0)
   {
    if (ord=="Buy")  ticket=OrderSend(Symbol(),OP_BUY, Lot,Ask,3,0,0," ",0,0);
    if (ord=="Sell") ticket=OrderSend(Symbol(),OP_SELL,Lot,Bid,3,0,0," ",0,0);
    if (ticket==-1)
     {  
      Alert (" ",GetLastError(),"   !");
      Print (" ",GetLastError(),"   !");
     }
    else
     {   
      Alert ("   RM ",RM,"%\nwww.mt4.ucoz.com");
      Print ("   RM ",RM,"%");
      return (0);
     }
   }
  return;
 } 
//+------------------------------------------------------------------+

